using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;

namespace Weapons
{
    public class Weapons
    {
        public static void Main()
        {

//WEAPONS

//Pistol
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Pistol",
                    NameToOrderByOverride = "+APL[Heavy]",
                    DescriptionOverride = "Cartoon pistol",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/gun.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/gun.png", 0.95f);
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.25f, 0.1f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<PolygonCollider2D>();        
                        Instance.FixColliders();
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
			            Cartridge customCartridge = ModAPI.FindCartridge("50 AE");
                        customCartridge.name = "Pistol";
                        customCartridge.Damage *= 2f;
                        customCartridge.StartSpeed *= 5f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 5f;
                        customCartridge.Recoil *= 0.2f;
                        customCartridge.ImpactForce *= 0f; 
			            firearm.Cartridge = customCartridge;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Weapon");
                        phys.TrueInitialMass = 0.10f;
                        phys.InitialMass = 0.10f;
                        phys.rigidbody.mass = 0.10f;
  
                        firearm.BulletsPerShot = 1;
                        firearm.AutomaticFireInterval = 1f;
                        firearm.Automatic = true;
                        firearm.InitialInaccuracy = 0f;
                        
			            firearm.ShotSounds = new AudioClip[]
						{
                           ModAPI.LoadSound("Sound/gun.mp3"),
						};
				    }
				}
            );
           
           //trolldge.........
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Trollge shotgun",
                    NameToOrderByOverride = "+APL[Shotgun]",
                    DescriptionOverride = "trolldge...",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/shotgun2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/shotgun2.png", 1f);
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.3f, 0.1f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<PolygonCollider2D>();        
                        Instance.FixColliders();
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
			            Cartridge customCartridge = ModAPI.FindCartridge("50 AE");
                        customCartridge.name = "shotgun)";
                        customCartridge.Damage *= 2f;
                        customCartridge.StartSpeed *= 5f;
                        customCartridge.PenetrationRandomAngleMultiplier *= 5f;
                        customCartridge.Recoil *= 0.2f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Weapon");
                        phys.TrueInitialMass = 0.10f;
                        phys.InitialMass = 0.10f;
                        phys.rigidbody.mass = 0.10f;

                        customCartridge.ImpactForce *= 0f;
			            firearm.Cartridge = customCartridge;    
                        firearm.BulletsPerShot = 3;
                        firearm.AutomaticFireInterval = 1f;
                        firearm.Automatic = false;
                        firearm.InitialInaccuracy = 0.3f;
                        
			            firearm.ShotSounds = new AudioClip[]
						{
                           ModAPI.LoadSound("Sound/shotgun2.mp3"),
						};
				    }
				}
            );

            //Kitchen Knife
			ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = "Kitchen Knife",
                        NameToOrderByOverride = "+APL[knife]",
                        DescriptionOverride = " ",
                        CategoryOverride = ModAPI.FindCategory("Melee"),
                        ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/knife.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/kitchen_knife.png", 1f);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.AddComponent<PolygonCollider2D>();        
                        }
                    }
                );
                
//HUMANS

//Trollface
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Trollface",
                    NameToOrderByOverride = "+APL",
                    DescriptionOverride = "Trololololo",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/trollface.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Humans/trollface.png");
                        var flesh = ModAPI.LoadTexture("Humans/trollface_flesh.png");
                        var bone = ModAPI.LoadTexture("Humans/trollface_bones.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );

//Pokerface
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Pokerface",
                    NameToOrderByOverride = "+APL",
                    DescriptionOverride = "...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/pokerface.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Humans/pokerface.png");
                        var flesh = ModAPI.LoadTexture("Humans/pokerface_flesh.png");
                        var bone = ModAPI.LoadTexture("Humans/pokerface_bones.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );

                //Instance.AddComponent<SvitAnim>();
        }
    }
    public class BurstFireAdapter : MonoBehaviour
    {
        public float Interval = 0.1f;
        public int BurstCount = 5;

        private bool busy = false;

        private CanShoot firearm;

        private void Awake()
        {
            firearm = GetComponent<CanShoot>();
        }

        private void Use()
        {
            StartCoroutine(Burst());
        }

        private System.Collections.IEnumerator Burst()
        {
            if (busy) yield break;
            busy = true;
            for (int i = 0; i < BurstCount - 1; i++)
            {
                yield return new WaitForSeconds(Interval);
                firearm.Shoot();
            }
            busy = false;
        }
    } 
}   